#include <fstream>
#include <vector>
using namespace std;

ifstream fin("lumina.in");
ofstream fout("lumina.out");

vector<int> convertToArray(string sir){
    vector<int> res;

    for(const auto &p : sir)
        res.push_back(p - '0');

    return res;
}
void computeXor(vector<int> &A, string B){
    int ind = 0;

    for(auto &p : A)
        p = p ^ (B[ind++] - '0');
}

bool checkSolution(vector<int> sir, int L, int M){
    int pos = 0, op = 0;

    while(pos < sir.size()){
        if(sir[pos] == 0)
            op++, pos += L;
        else pos++;

        if(op > M)
            return false;
    }
    return true;
}

int findL(vector<int> sir, int M){
    int st = 0, dr = sir.size(), ans = -1;

    while(st <= dr){
        int mid = (st + dr) / 2;

        if(checkSolution(sir, mid, M)){
            ans = mid;
            dr = mid - 1;
        }
        else st = mid + 1;
    }

    return ans;
}
int main() {
    int N, P, M;

    fin >> N >> P >> M;

    string A;
    fin >> A;
    vector <int> res;
    res = convertToArray(A);

    for(int i = 1; i < N; ++i){
        string B;
        fin >> B;

        computeXor(res, B);
    }

    fout << findL(res, M);
}